package ipl;
import java.net.URL;
import java.applet.Applet;
import java.awt.*;
import java.awt.image.*;
import futils.utils.*;

public class DoublePlane {
	public double r[];
	public double g[];
	public double b[];
	private int width;
	private int height;
	ColorModel cm ;
	ProcessPlane pp;
	

	
	
DoublePlane(ProcessPlane pp_) {
	pp = pp_;
	width = pp.getWidth();
	height = pp.getHeight();
	int l = width*height;
	r = new double[l];
	g = new double[l];
	b = new double[l];
	cm = ColorModel.getRGBdefault();
	for (int i=0; i < l; i++) {
		r[i] = (double) pp.getRed(i);
		g[i] = (double) pp.getGreen(i);
		b[i] = (double) pp.getBlue(i);
	}
}

public ProcessPlane makeProcessPlane() {

	for (int i =0; i < r.length; i++) {
		pp.setPixel(i,(int) r[i],(int) g[i], (int) b[i],255);
	}
	return pp;
}		
public int getLength() {
	return r.length;
}
public int getHeight() {
	return height;
}
public int getWidth() {
	return width;
}

public double getRed(int i) {
	return r[i];
}

public double getGreen(int i) {
	return g[i];
}

public double getBlue(int i) {
	return b[i];
}

public double getAlpha(int i) {
	return (double) pp.getAlpha(i);
}


public double getRed(int x, int y) {
		if (inrange(x,y)) {
			return getRed(y*width + x);
			}
		else {return 0;}
	}

public double getGreen(int x, int y) {
		if (inrange(x,y)) {
			return getGreen (y*width + x);
						}
		else {return 0;}

	}
	
public double getBlue(int x, int y) {
			if (inrange(x,y)) {
				return getBlue  (y*width + x);
									}
		else {return 0;}

	}
	
public double getAlpha(int x, int y) {
			if (inrange(x,y)) {
					return getAlpha (y*width + x);
													}
		else {return 0;}
}


boolean inrange(int x, int y) {
	return ((x < width) && (y < height));
}
	

public void setPixel(int x, int y, 
	double r_, double g_, double b_) {
	int i = y * width + x;
	r[i] = r_;
	g[i] = g_;
	b[i] = b_;
}

public void setPixel(int i, double r_, double g_, double b_) {
	r[i] = r_;
	g[i] = g_;
	b[i] = b_;
}
	
public void printSize() {
		System.out.println(
			"W:"+
			width +
			" H:"+ 
			height);
}

}