package lyon;
import java.applet.*;
import java.util.*;
import java.awt.*;
import java.io.*;
import futils.utils.*;
import grapher.*;
import lyon.audio.*;
import gui.*;
import observers.ObservableDouble;


public class GUI  extends Applet implements constants  {
    Choice mouseChoice;
    String objectPropertiesStr = new String("Object Properties");
    String cameraStr = new String("camera");
    String laserStr = new String("laser");
    String laserAngleStr = new String("laser angle");
    String gratingStr = new String("grating");
    String graphPvsXStr = new String("graph p vs x");
    String graphDLvsXStr = new String("graph DL vs x");
    String allStr = new String("all");
    
    String mouseChoiceItems[] = {
    	objectPropertiesStr, 
    	cameraStr, laserStr, laserAngleStr, gratingStr, 
    	graphPvsXStr, graphDLvsXStr, allStr
    };
    
  static String  version = "Ver  3.4 ";
  
 
   
   Grid grid = new Grid();
   	
   static Vector  drawnShapes;
   public static  Frame gf = new Frame("Graph Frame");

   Checkbox ap_cb = new Checkbox("Auto-pan",null,true);
   Checkbox order_cb = new Checkbox("-order",null,true);
   Checkbox i3_cb = new Checkbox("-i3");
   Checkbox r3_cb = new Checkbox("-r3",null,true);
   Checkbox x3_cb = new Checkbox("-x3",null,false);

   Checkbox checkboxes[] = {
   	ap_cb,
   	order_cb,
   	i3_cb,
   	r3_cb,
   	x3_cb};
    


   	
   	Camera c = (Camera) Geometry.camera;   	
   	Grating g = (Grating) Geometry.grating;
   	
 
   
   // Used for the mouse drag feature.
   point   anchor; 
   
   public static MenuBarFrame main_frame = new 
      	MenuBarFrame("DiffCAD " + version);
   
  public void create_gui() {
   	setBackground(Color.white);
	Guitils.addCheckBoxes(checkboxes, this);
	mouseChoice = Guitils.addChoiceMenu(mouseChoiceItems, this);
	Guitils.addLabel(Geometry.grid.width, this);
	Guitils.addLabel(Geometry.lambda, this);
	Guitils.addLabel(c.rotation, this);
	Guitils.addLabel(c.F, this);
	Guitils.addLabel(c.A, this);
	Guitils.addLabel(g.getPitch1(), this);
	Guitils.addLabel(g.getPitch2(), this);
	Guitils.addLabel(Geometry.laser.rotation, this);

   }
   
 public static void create_main_frame(Main m) {
    // put the applet into the frame
   	 main_frame.add("Center", m);
    // give the frame a default size
     main_frame.setSize(400,400);
    // make the frame appear
     main_frame.show(); 
      		
 }
   
   
    public void update_dl(Dl dl) {
	double t;
	double x1,y1,x2,y2;
	int i;
	int j;
	int number_of_rays = Geometry.number_of_rays.getValue()-1;
	Camera c = (Camera) Geometry.camera;
	x1 = Geometry.laser.p1.x;
	y2 = Geometry.laser.p1.y;
	t = 0;
	boolean bad_data = false;
	double x_delta = (c.x_max() - c.x_min())/number_of_rays;
	double x = c.x_min();
	int k;
	System.out.println("xmin is"+x+ " x_delta is "+x_delta);
		for (i=0; i <= number_of_rays; i++) {
			dl.x_data[i] = x;
			//k =i; // number_of_rays -i;
			k= number_of_rays -i;
			GratingTargetLine gtl = 
				(GratingTargetLine) Geometry.grating_target_line[k];
			
			dl.y_data[i] = gtl.target.p1.y/
				Math.cos( Geometry.laser.rotation.getValue() * Pi_on_180);
			if (gtl.target.p1.y <= 0) {
				dl.y_data[i]=0; //target below grating !
				//  data will be zero
			} // if
			

		   	x = x + x_delta;
		
		if (x3_cb.getState()) { // if checkbox then negate
		    dl.x_data[i] = dl.x_data[i] * -1;
		   } // if

   		} // for
   		dl.np = i; // incase we broke
	} // update_dl

    public void update_dons_dl(Dl dl) {
	double t;
	double x1,y1,x2,y2;
	int i;
	int j;
	int number_of_rays = Geometry.number_of_rays.getValue()-1;
	Camera c = (Camera) Geometry.camera;
	Laser l = (Laser) Geometry.laser;
	x1 = Geometry.laser.p1.x;
	y2 = Geometry.laser.p1.y;
	t = 0;
	boolean bad_data = false;
	double x_delta = (c.x_max() - c.x_min())/number_of_rays;
	double x = c.x_min();
	int k;
	double dons_dl,kappa;
	double  F, rho, alpha, d, r, s, n, pitch, lambda,kappa2;
	System.out.println("xmin is"+x+ " x_delta is "+x_delta);
	System.out.println("Don's DL, Computed:");
		for (i=0; i <= number_of_rays; i++) {
			dl.x_data[i] = x;
			//k =i; // number_of_rays -i;
			k= number_of_rays -i;
			GratingTargetLine gtl = 
				(GratingTargetLine) Geometry.grating_target_line[k];
			rho = c.rotation.getValue() * Math.PI/180;
			F = c.F.getValue();
			pitch = c.compute_pitch(x);
			n = Geometry.n.getValue();
			lambda = Geometry.lambda.getValue();
			r = rho + Math.atan(x/F);
			s = Geometry.s();
			d = c.compute_d();
			alpha = l.compute_alpha_radians();
			kappa2 = n * lambda / pitch - Math.sin(r);
			kappa = -Math.sqrt(1-kappa2*kappa2)/kappa2;
			// dons_dl = kappa*Math.abs(d*Math.tan(r) - s)/
			dons_dl = - kappa*(d*Math.tan(r) - s)/
						(Math.cos(alpha) - kappa *Math.sin(alpha));
			
			dl.y_data[i] = dons_dl;
			if (gtl.target.p1.y <= 0) {
				dl.y_data[i]=0; //target below grating !
				//  data will be zero
			} // if
			

		   	x = x + x_delta;
		
		if (x3_cb.getState()) { // if checkbox then negate
		    dl.x_data[i] = dl.x_data[i] * -1;
		   } // if

   		} // for
   		dl.np = i; // incase we broke
	} // update_dons_dl

void add_rays() {
   	Geometry.add_elements(drawnShapes);			
   	repaint();
 } // add_rays
 
 public void print_dl() {
 	int i = Geometry.number_of_rays.getValue();
	Dl dl = new Dl(i,"x3", "DL");
 	update_dl(dl);
 	dl.print();
   } // print_dl
   
public void init_gui() {

  create_gui();
  drawnShapes = new Vector();
		Geometry.init();
		add_rays();
   }
   

   
   public boolean handleEvent(Event e) {
   	
   	switch (e.id) {
   		
   		case Event.MOUSE_UP:  {
      				String objectName = mouseChoice.getSelectedItem();      
      				processMouseUp( objectName,  e.x,  e.y);
      				repaint();
  	 	} 
  	 	case Event.MOUSE_DOWN: 
  	 		anchor = new point( e.x, e.y);
  	 		
  	  return super.handleEvent(e);

      	} // switch
      	


   	
   	Camera c = (Camera) Geometry.camera;
   	c.i3_negative = i3_cb.getState();
   	c.r3_negative = r3_cb.getState();
   	c.order_negative = order_cb.getState();
   	if (order_cb.getState()) 
   			{Geometry.n.setValue(-1);}	
   			else 
   			{Geometry.n.setValue(-1);}
			
   	   return super.handleEvent(e);
   }
 
 public void make_graph_dl() {
 		Dl dl = new 
 		Dl(Geometry.number_of_rays.getValue(),
 		"x ", "DL ");
 		update_dl(dl);

  		g2d1 graph_frame = new g2d1(dl);

		graph_frame.g = getGraphics();
		graph_frame.draw();

  }
        public void make_graph_p() {
        int i = Geometry.number_of_rays.getValue();
 		Dl dl = 
 			new Dl(i,"x3*10", "Pitch");
 		update_p(dl);

  		g2d1 graph = new g2d1(dl);

		graph.g = getGraphics();
		graph.draw();
  }
  
   public void update_p(Dl p) {
	double t = 0;
	Camera c = (Camera) Geometry.camera;
	int nor = Geometry.number_of_rays.getValue();
	double dt = Geometry.delta_t();
	double x_delta = (c.x_max() - c.x_min())/nor;
	double x=c.x_min();
	for (int i=0; i < nor; i++) {
		GratingTargetLine gtl = 
			(GratingTargetLine) Geometry.grating_target_line[i];
		
		p.x_data[i] = x;
		p.y_data[i] = c.compute_pitch(x);
		if (x3_cb.getState()) {
		    p.x_data[i] = p.x_data[i] * -1;
		   }
   		t = t + dt;
   		x = x + x_delta;
   	}
} // up_date_p


  public void processMouseUp(String object_name, int x, int y) {
      point rmove = new point(x-anchor.x, anchor.y - y);
      // rmove is the relative motion of the mouse. 
        if ( object_name.equals(cameraStr)) {
      		Camera c = (Camera) Geometry.camera;
      		c.auto_pan = ap_cb.getState();
      		System.out.println("Auto pan is"+c.auto_pan);
      		c.change_config(rmove);
     		
      		Geometry.compute_rays();

      	} 
      	if ( object_name.equals(laserStr)) {
      		Laser l = (Laser) Geometry.laser;
      		l.change_config(rmove);
      		Geometry.compute_rays();
      	}
      	if ( object_name.equals(gratingStr)) {
      		Grating g = (Grating) Geometry.grating;
      		g.change_config(rmove);
      		Geometry.compute_rays();
      	}
      	if ( object_name.equals(graphDLvsXStr)) 
      		make_graph_dl();
    	
    	if ( object_name.equals(graphPvsXStr)) 
      		 make_graph_p();
	
		if (object_name.equals(laserAngleStr)) {
      		Wedge w = (Wedge) Geometry.wedge;
      		w.change_config(rmove);
      		Geometry.compute_rays();
      		return;
      	} 
      	if (object_name.equals(allStr)) {
	 		Xform.rmove(rmove); 
	 		return;
	 	}
   		
   }
  


   

   public boolean keyDown(Event evt, int key) {

   	int number_of_shapes;
   	Shape  s;


   	int d = Geometry.step_size.getValue(); // mm increment on motion
	point np = new point(0,0);
	point ns = new point(1,1);
   	System.out.println("ASCII value: " + key);
   	System.out.println("Character: " + (char) key);
   	switch (key) {
   		case 'd':
   			print_dl();
   			break;
   		case 'a':
   			Geometry.print_angles();
   			break;
   		case 'p':
   			Geometry.print();
   			break;
   		case '6':
   			np.x +=d;
   			Xform.rmove(np);
   			break;
   		case '2':
   			np.y -=d;
   			Xform.rmove(np);
   			break;
   		case '3':
   			np.x +=d;
   			np.y -=d;
   			Xform.rmove(np);
   			break;
   		case '1':
   			np.x -=d;
   			np.y -=d;
   			Xform.rmove(np);
   			break;
   		 case '7':
   			np.x -=d;
   			np.y +=d;
   			Xform.rmove(np);
   			break;
   		case '9':
   			np.y +=d;
   			np.x +=d;
   			Xform.rmove(np);
   			break;
   		case '4':
   			np.x -=d;
   			Xform.rmove(np);
   			break;
   		case '8':
   			np.y +=d;
   			Xform.rmove(np);
   			break;
   		
   		case '-':
   			ns.y += -.25;
   			ns.x = ns.y;
   			Xform.rscale(ns);
   			break;
   		case '+':
   			ns.y += .25;
   			ns.x = ns.y;
   			Xform.rscale(ns);
   			break;
   		}
   	repaint();
   	return false;
   } // keyDown
   
  synchronized  public void paint(Graphics g) {
     	// draw.grid(g);
     	Geometry.grid.draw(g);

	Geometry.compute_rays();
    Shape s;
    for (int i = 0; i < drawnShapes.size(); i++) {
         s = (Shape)drawnShapes.elementAt(i);
         s.draw(g);  
      }
  }
           
}