package lyon.surfer;
/******************************************************************************************

 * Surface Plotter version 1.10                                               Oct 14 1996 *

 * Surface Plotter version 1.20                                               Nov  8 1996 *

 *                                                                                        *

 * FunctionPanel.java: Function Panel of Surface Plotter                                  *

 *                                                                                        *

 * Copyright (c) 1996 Yanto Suryono. All Rights Reserved.                                 *

 *                                                                                        *

 * Permission to use, copy, and distribute this software for NON-COMMERCIAL purposes      *

 * and without fee is hereby granted, provided that this copyright notice appears in all  *

 * copies and this software is not modified in any way                                    *

 *                                                                                        *

 * Please send bug reports and/or corrections/suggestions to                              *

 * Yanto Suryono <d0771@cranesv.egg.kushiro-ct.ac.jp>                                     *

 ******************************************************************************************/



import java.awt.*;



public class FunctionPanel extends Panel {

  private TextField function1, function2;  

  private TextField message;

  private Checkbox delay_regen, func1select, func2select;

  private Choice plot_mode;

  

  /*--------------------------------------------------------------------------------                     

                            Constructor for FunctionPanel

    --------------------------------------------------------------------------------*/  



  FunctionPanel() {

    setBackground(Color.lightGray);

    setLayout(new BorderLayout());



    Panel funcline, modeline, infopanel, subpanel, selectpanel;

    

    funcline = new Panel();

    funcline.setLayout(new BorderLayout());   

    funcline.add("West", subpanel = new Panel());

    subpanel.setLayout(new GridLayout(2,1));

    subpanel.add(selectpanel = new Panel());

    selectpanel.setLayout(new BorderLayout());

    selectpanel.add("West", func1select = new Checkbox());

    func1select.setState(true);

    selectpanel.add("Center", message = new TextField("z1(x,y)"));

    message.setEditable(false);

    subpanel.add(selectpanel = new Panel());

    selectpanel.setLayout(new BorderLayout());

    selectpanel.add("West", func2select = new Checkbox());

    selectpanel.add("Center", message = new TextField("z2(x,y)"));

    message.setEditable(false);

    funcline.add("Center", subpanel = new Panel());

    subpanel.setLayout(new GridLayout(2,1));      

    subpanel.add(function1 = new TextField());

    subpanel.add(function2 = new TextField());

        

    modeline = new Panel();

    modeline.setLayout(new BorderLayout());

    add("South", modeline);

    add("Center", subpanel = new Panel());

    subpanel.setLayout(new BorderLayout());



    subpanel.add("East", new SurfaceLogo());

    subpanel.add("Center", funcline);



    modeline.add("West",delay_regen = new Checkbox("Delay Regeneration"));

    modeline.add("Center", modeline = new Panel());

    

    plot_mode = new Choice();

    plot_mode.addItem("Wireframe     ");

    plot_mode.addItem("Hidden Surface");

    plot_mode.addItem("Color Spectrum");

    plot_mode.addItem("Gray Level    ");

    plot_mode.addItem("Dual Shade    ");



    modeline.setLayout(new BorderLayout());

    modeline.add("West",plot_mode);

    modeline.add("Center",modeline = new Panel());

    modeline.setLayout(new BorderLayout());

    modeline.add("North",modeline = new Panel());

    modeline.setLayout(new BorderLayout());

    modeline.add("Center",message = new TextField());

    message.setEditable(false);

  }

  

  /*--------------------------------------------------------------------------------                     

              Returns whether Surface Plotter should delay regeneration 

                       until mouse buttons have been released 

    --------------------------------------------------------------------------------*/  



  public boolean isExpectDelay() {

    return delay_regen.getState();

  }



  /*--------------------------------------------------------------------------------                     

                        Returns whether a function is selected

    --------------------------------------------------------------------------------*/  



  public boolean isFunction1Selected() {

    return func1select.getState();

  }

  

  public boolean isFunction2Selected() {

    return func2select.getState();

  }

    

  /*--------------------------------------------------------------------------------                     

                             Returns selected plot mode 

    --------------------------------------------------------------------------------*/  



  public int getPlotMode() {

    return plot_mode.getSelectedIndex();

  }

  

  /*--------------------------------------------------------------------------------                     

                          Sets message (status information) 

    --------------------------------------------------------------------------------*/  



  public void setMessage(String text) {

    message.setText(text);

  }

  

  /*--------------------------------------------------------------------------------                     

                             Returns function definition

    --------------------------------------------------------------------------------*/  



  public String getFunction1Definition() {

    return function1.getText();

  }



  public String getFunction2Definition() {

    return function2.getText();

  }

  

  /*--------------------------------------------------------------------------------                     

                                 Handles user actions 

    --------------------------------------------------------------------------------*/  



  public boolean action(Event e, Object arg) {

    if (e.target instanceof Checkbox) {          

      if (e.target != delay_regen) return false; // propagates to parent 

    }

    else

    return super.action(e,arg);      

    return true;

  }

}





